
	LIST   P=PIC16F628            ;
	#include <P16F628.INC>        ;

 __CONFIG _CP_ALL & _DATA_CP_ON & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _INTRC_OSC_NOCLKOUT  & _MCLRE_OFF & _LVP_OFF 


;***************
BANK0   macro		      ;
	BCF	STATUS,RP1
	BCF	STATUS,RP0       ;
	endm
;***************
BANK1   macro		;------------------------------------------;
	BCF	STATUS,RP1       ;
	BSF	STATUS,RP0       ;
	endm
;***************
BANK2   macro		;------------------------------------------;
	BSF	STATUS,RP1
	BCF	STATUS,RP0       ;
	endm
;***************
BANK3   macro		         ;
	BSF	STATUS,RP1
	BSF	STATUS,RP0
	endm

;***********************************************************************************
#define   FLOG_0        FLOG,0 ;
#define   FLOG_1        FLOG,1 ;
#define   FLOG_2        FLOG,2 ;
#define   FLOG_3        FLOG,3 ;  
#define   FLOG_4        FLOG,4 ;   1 ,   EEPROM
#define   FLOG_5        FLOG,5 ;
#define   FLOG_6        FLOG,6 ;
#define   FLOG_7        FLOG,7 ;

#define   FLUG_0        FLUG,0 ;
#define   FLUG_1        FLUG,1 ;
#define   FLUG_2        FLUG,2 ;
#define   FLUG_3        FLUG,3 ;
#define   FLUG_4        FLUG,4 ;
#define   FLUG_5        FLUG,5 ; 
#define   FLUG_6        FLUG,6 ;
#define   FLUG_7        FLUG,7 ;

#define   FLAG_0        FLAG,0 ;
#define   FLAG_1        FLAG,1 ;
#define   FLAG_2        FLAG,2 ;
#define   FLAG_3    	FLAG,3 ;
#define   FLAG_4        FLAG,4 ;
#define   FLAG_5        FLAG,5 ;
#define   FLAG_6        FLAG,6 ;
#define   FLAG_7	FLAG,7 ;

; 

W_AKAM 		EQU        0x4B        ;
STATUS_RAM	EQU        0x4A        ;

IND_3      	EQU        0x49
IND_2      	EQU        0x48
IND_1      	EQU        0x47
IND_0      	EQU        0x46

cicle      	EQU        0x45

FLAG			EQU	           0x44         ;   
FLUG			EQU		   0x43
FLOG			EQU		   0x34
COUNT_ML		EQU		   0x28
COUNT_ST		EQU		   0x29

COUNG_ML		EQU		   0x41
COUNG_ST		EQU		   0x42

COANT_ML		EQU		   0x2A
COANT_ST		EQU		   0x2B

CAANT_ML		EQU		   0x2F
CAANT_ST		EQU		   0x30


CAAND_ML		EQU		   0x32
CAAND_ST		EQU		   0x33

COAND_ML		EQU		   0x35
COAND_ST		EQU		   0x36

DOPDED1		        EQU		   0x4D

DOPDED2		        EQU		   0x4E

MATDED1		        EQU		   0x4F
MATDED2		        EQU		   0x50
MATDED3		        EQU		   0x51
MATDED4		        EQU		   0x52

TEMP1	        	EQU		   0x3F

;*****************************************************************************************
bcd1			EQU		   0x20
bcd2			EQU		   0x21
bcd3			EQU		   0x22
bin1			EQU		   0x23
bin2			EQU		   0x24
ctr			EQU		   0x25
fCOUNTER		EQU		   0x26
fCOUNTER1	        EQU		   0x27
DfCOUNTER	        EQU		   0x2C
TIME0   		EQU		   0x2D
MENS	        	EQU		   0x2E
MENSR	   	EQU		   0x37
VVOD	       	EQU		   0x38
BACKUPB		EQU		   0x39
BACKUPA		EQU		   0x40
CVREM_ML	EQU		   0x3A
CVREM_ST	EQU		   0x3B
KOLCO		EQU		   0x3C
KOPY_ADR	EQU		   0x3D
KOPY_D		EQU		   0x3E
T_ZAP      	EQU                0x4C

STOPN11	        EQU                0x53
STOPN12	        EQU                0x54
STOPN13	        EQU                0x56

STOPK11	        EQU                0x57
STOPK12	        EQU                0x58
STOPK13         EQU                0x59

STOPN21	        EQU                0x5A
STOPN22	        EQU                0x5B
STOPN23	        EQU                0x5C

STOPK21	        EQU                0x5D
STOPK22	        EQU                0x5E
STOPK23	        EQU                0x5F
PAM1	        EQU                0x60
PAM2	        EQU                0x61
Reg_1	        EQU                0x62
Reg_2	        EQU                0x63
Reg_3	        EQU                0x64
;******************************************************************************************
          ;      
           ORG    2100h       ;    EEPROM
           DE     0h, 0h, 0h, 0h, 0h, 0h  ;   
           DE     0h, 0h, 0h, 0h, 0h, 0h  ;   
           DE     0h, 0h, 0h, 0h, 0h, 0h  ;   
           DE     0h, 0h, 0h, 0h, 0h, 0h  ;   
           DE     0h, 0h, 0h, 0h, 0h, 0h  ;   
;******************************************************************************************
;******************************************************************************************
		ORG     0x000             ;  
;*************4 mgz
		BANK0
        MOVLW	B'00000111'    ;.7,0x07,  
        MOVWF	CMCON          ; 

	BANK1
        MOVLW   	B'11110111'    ; PORTB 
        MOVWF   	TRISB^80H      ;
        MOVLW   	B'00110011'    ; PORTA
        MOVWF   	TRISA^80H      ;

		MOVLW	B'01000011'	;
		MOVWF	OPTION_REG	; 1:16
	BANK0

		MOVLW	B'00000000'	;
		MOVWF	INTCON

        BCF     PORTA,6 
        BCF     FLUG_6    ;˨ ,6
        BCF     PORTA,7  
        BCF     FLUG_7    ;˨ ,7
        BCF     PORTA,2 
        BCF     FLUG_5    ;˨ ,2
        BCF     PORTA,3
        BCF     FLUG_1    ;˨ ,3
	clrf	COUNT_ML
	clrf	COUNT_ST 
	clrf	COUNG_ML
	clrf	COUNG_ST 
  
        CLRF    COANT_ST
        CLRF    COANT_ML
        CLRF    DOPDED1
        CLRF    DOPDED2
        CLRF    MATDED1
        CLRF    MATDED2
        CLRF    MATDED3
        CLRF    MATDED4
        CLRF    CAANT_ML
        CLRF    CAANT_ST
        CLRF    CAAND_ML
        CLRF    CAAND_ST
        CLRF    COAND_ML
        CLRF    COAND_ST
        CLRF    STOPK11
        CLRF    STOPK12
        CLRF    STOPK13
        CLRF    STOPK21
        CLRF    STOPK22
        CLRF    STOPK23
        CLRF    STOPN11
        CLRF    STOPN12
        CLRF    STOPN13
        CLRF    STOPN21
        CLRF    STOPN22
        CLRF    STOPN23

        CLRF    PAM1
        CLRF    PAM2

	CLRF    FLUG
	CLRF	FLAG
        CLRF    FLOG
        BSF     FLAG_5
        BSF     FLAG_7
        BSF     FLAG_6
        BSF     FLOG_3

       ;  EEPROM
        MOVLW	.0
        MOVWF   KOPY_ADR    ; 
        CALL    READEE     ;  
        MOVWF   COUNT_ML    ; 
        MOVLW	.1
        MOVWF   KOPY_ADR    ; 
        CALL    READEE     ;  
        MOVWF   COUNT_ST    ; 
        MOVLW	.2
        MOVWF   KOPY_ADR    ; 
        CALL    READEE     ;  
        MOVWF   COUNG_ML    ; 
        MOVLW	.3
        MOVWF   KOPY_ADR    ; 
        CALL    READEE     ;  
        MOVWF   COUNG_ST    ; 
        MOVLW	.4
        MOVWF   KOPY_ADR    ; 
        CALL    READEE     ;  
        MOVWF   DOPDED1    ;
        MOVLW	.5
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   DOPDED2    ;  
        MOVLW	.6
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   COANT_ML    ; 
        MOVLW	.7
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   COANT_ST    ; 
        MOVLW	.8
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   MATDED3    ;
        MOVLW	.9
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   CAAND_ML    ; 
        MOVLW	.10
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   CAAND_ST    ; 
        MOVLW	.11
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   MATDED4    ;
        MOVLW	.12
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   CAANT_ML    ; 
        MOVLW	.13
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   CAANT_ST    ; 
        MOVLW	.14
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   MATDED1    ;
        MOVLW	.15
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   COAND_ML    ; 
        MOVLW	.16
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   COAND_ST    ; 
        MOVLW	.17
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   MATDED2    ;
        MOVLW	.18
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   STOPK13    ;
        MOVLW	.19
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   STOPK12    ;
        MOVLW	.20
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   STOPK11    ;
        MOVLW	.21
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   STOPK21    ;
        MOVLW	.22
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   STOPK22    ;
        MOVLW	.23
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   STOPK23    ;
        MOVLW	.24
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   PAM1       ;
        MOVLW	.25
        MOVWF   KOPY_ADR    ; 
        CALL    READEE
        MOVWF   PAM2       ;

;*********************************************************************************
SNOVA
                BTFSC   PORTA,1          ;0      1
                GOTO    ZZYY
                CLRF    PAM1

                BSF     PORTB,3
                CALL	Pause
                BCF     PORTB,3
                BTFSC   PORTA,1          ;0      1
                GOTO    ZZYZ
                INCF    PAM1

                MOVF    DOPDED1,0        ;    (W=0)
                MOVWF   STOPK13
                MOVF    COUNT_ST,0       ;   COUNT_ST   (W=0)
                MOVWF   STOPK12
                MOVF    COUNT_ML,0       ;  
                MOVWF   STOPK11
 LOVU1          BTFSS   PORTA,1          ;0      1
                GOTO    LOVU1

        MOVLW	.18
        MOVWF   KOPY_ADR    ;
        MOVF    STOPK13, 0    ;  W
        MOVWF   KOPY_D      ; 
        CALL    WRITEE    ;  
        MOVLW	.19
        MOVWF   KOPY_ADR    ;
        MOVF    STOPK12, 0   ;  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE    ;  
        MOVLW	.20
        MOVWF   KOPY_ADR    ;
        MOVF    STOPK11, 0   ;  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE    ;  
 ZZYZ   MOVLW	.24
        MOVWF   KOPY_ADR    ;
        MOVF    PAM1, 0   ;  PAM1  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE    ;  
ZZYY
;*********************************************************************************
                BTFSC   PORTA,4          ;0      2
                GOTO    ZZPP
                CLRF    PAM2

                BSF     PORTB,3
                CALL	Pause
                BCF     PORTB,3
                BTFSC   PORTA,4          ;0      2
                GOTO    ZZPY
                INCF    PAM2

                MOVF    COUNG_ML,0      ;    (W=0)
                MOVWF   STOPK21
                MOVF    COUNG_ST,0      ;    (W=0)
                MOVWF   STOPK22
                MOVF    DOPDED2,0      ;  
                MOVWF   STOPK23
 LOVU           BTFSS   PORTA,4          ;0      2
                GOTO    LOVU

        MOVLW	.21
        MOVWF   KOPY_ADR    ;
        MOVF    STOPK21, 0    ;  W
        MOVWF   KOPY_D      ; 
        CALL    WRITEE    ;  
        MOVLW	.22
        MOVWF   KOPY_ADR    ;
        MOVF    STOPK22, 0   ;  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE    ;  
        MOVLW	.23
        MOVWF   KOPY_ADR    ;
        MOVF    STOPK23, 0   ;  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE    ;  
 ZZPY   MOVLW	.25
        MOVWF   KOPY_ADR    ;
        MOVF    PAM2, 0   ;  PAM2  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE    ;  
ZZPP

;*********************************************************************************
;*****************  ,  +++ ---
                BTFSC   FLUG_6      ; 1 .  -2
                GOTO    HOD3

                BTFSC   PORTB,7            ; 0    -2
                GOTO    HOD3
                BTFSS   FLAG_7            ; 1   -2,   
                GOTO    HOD3
                BSF     PORTA,7
                BSF     FLUG_7    ;˨ ,7
                BSF     FLAG_4
                GOTO    HODS3
 HOD3           BTFSS   FLAG_4            ;1 
                GOTO    HODS3
                BCF     PORTA,7
                BCF     FLUG_7    ;˨ ,7
                BCF     FLAG_4

 HODS3          BTFSC   FLUG_7       ;  1 .  +2
                GOTO    HOD2

                BTFSC   PORTB,6            ; 0    +2
                GOTO    HOD2
                BTFSS   FLAG_6            ; 1   +2,   
                GOTO    HOD2
                BSF     PORTA,6
                BSF     FLUG_6    ;˨ ,6
                BSF     FLAG_3
                GOTO    HODS2
 HOD2           BTFSS   FLAG_3            ;1 
                GOTO    HODS2
                BCF     PORTA,6
                BCF     FLUG_6    ;˨ ,6
                BCF     FLAG_3

 HODS2          BTFSC   FLUG_1      ; 1 .  -1
                GOTO    HOD1

                BTFSC   PORTB,5            ; 0    -1
                GOTO    HOD1
                BTFSS   FLAG_5            ; 1   -1
                GOTO    HOD1
                BSF     PORTA,2
                BSF     FLUG_5    ;˨ ,2
                BSF     FLAG_2
                GOTO    HODS1
 HOD1           BTFSS   FLAG_2            ;1 
                GOTO    HODS1
                BCF     PORTA,2
                BCF     FLUG_5    ;˨ ,2
                BCF     FLAG_2

 HODS1          BTFSC   FLUG_5      ; 1 .  +1
                GOTO    HOD

                BTFSC   PORTB,4            ; 0    +1
                GOTO    HOD
                BTFSS   FLOG_3            ; 1   +1
                GOTO    HOD
                BSF     PORTA,3
                BSF     FLUG_1    ;˨ ,3
                BSF     FLAG_0
                GOTO    HODS
 HOD            BTFSS   FLAG_0            ;1 
                GOTO    HODS
                BCF     PORTA,3
                BCF     FLUG_1    ;˨ ,3
                BCF     FLAG_0
;*********************************************************************************
;*****************    

 HODS           BTFSS   PORTB,1            ;0    1
                GOTO    GHJ
                GOTO    GJH
 GHJ            BSF     FLUG_2
                BSF     FLUG_3
                
 GJH            BTFSS   PORTB,2            ;0    2
                GOTO    GHL
                GOTO    DD6
 GHL            BSF     FLUG_0       ;  ,6 ,7
                BSF     FLUG_4       ;  ,3 ,2

DD6             BTFSC   PORTB,0            ;0     1, 2 
                GOTO    FD51
                BSF     PORTB,3
                CALL	Pause
                BCF     PORTB,3

;*********************************************************************************
              ;   2 
                BTFSC   PORTB,2          ;0     2
                GOTO    FD5
                MOVF    COUNG_ML,0      ;      (W=0)
                MOVWF   COANT_ML
                MOVF    COUNG_ST,0      ;     (W=0)
                MOVWF   COANT_ST
                MOVF    DOPDED2,0      ; 
                MOVWF   MATDED3

                MOVF    COUNT_ML,0      ;   COUNT_ML   (W=0)
                MOVWF   CAAND_ML
                MOVF    COUNT_ST,0      ;   COUNT_ST   (W=0)
                MOVWF   CAAND_ST
                MOVF    DOPDED1,0      ;   
                MOVWF   MATDED4

        MOVLW	.6
        MOVWF   KOPY_ADR    ;
        MOVF    COANT_ML, 0    ;  COANT_ML  W
        MOVWF   KOPY_D      ; 
        CALL    WRITEE    ;  
        MOVLW	.7
        MOVWF   KOPY_ADR    ;
        MOVF    COANT_ST, 0   ;  COANT_ST  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE     ;  
        MOVLW	.8
        MOVWF   KOPY_ADR    ;
        MOVF    MATDED3, 0   ;  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE    ;  
        MOVLW	.9
        MOVWF   KOPY_ADR    ;
        MOVF    CAAND_ML, 0    ;  COANT_ML  W
        MOVWF   KOPY_D      ; 
        CALL    WRITEE    ;  
        MOVLW	.10
        MOVWF   KOPY_ADR    ;
        MOVF    CAAND_ST, 0   ;  COANT_ST  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE    ;  
        MOVLW	.11
        MOVWF   KOPY_ADR    ;
        MOVF    MATDED4, 0   ;  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE    ;  
               
FDZ5            BTFSS   PORTB,2          ;0     2
                GOTO    FDZ5
                GOTO    FD51
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
FD5            ;   1 
                BTFSC   PORTB,1          ;0     1
                GOTO    FD51
                MOVF    COUNT_ML,0      ;   COUNT_ML   (W=0)
                MOVWF   CAANT_ML
                MOVF    COUNT_ST,0      ;   COUNT_ST   (W=0)
                MOVWF   CAANT_ST
                MOVF    DOPDED1,0      ;  
                MOVWF   MATDED1

                MOVF    COUNG_ML,0      ;     (W=0)
                MOVWF   COAND_ML
                MOVF    COUNG_ST,0      ;     (W=0)
                MOVWF   COAND_ST
                MOVF    DOPDED2,0      ; 
                MOVWF   MATDED2

        MOVLW	.12
        MOVWF   KOPY_ADR    ;
        MOVF    CAANT_ML, 0    ;  COANT_ML  W
        MOVWF   KOPY_D      ; 
        CALL    WRITEE    ;  
        MOVLW	.13
        MOVWF   KOPY_ADR    ;
        MOVF    CAANT_ST, 0   ;  COANT_ST  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE     ;  
        MOVLW	.14
        MOVWF   KOPY_ADR    ;
        MOVF    MATDED1, 0   ;  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE    ;  
        MOVLW	.15
        MOVWF   KOPY_ADR    ;
        MOVF    COAND_ML, 0    ;  COANT_ML  W
        MOVWF   KOPY_D      ; 
        CALL    WRITEE    ;  
        MOVLW	.16
        MOVWF   KOPY_ADR    ;
        MOVF    COAND_ST, 0   ;  COANT_ST  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE    ;  
        MOVLW	.17
        MOVWF   KOPY_ADR    ;
        MOVF    MATDED2, 0   ;  W
        MOVWF   KOPY_D      ;
        CALL    WRITEE    ;  
        
FDZ6            BTFSS   PORTB,1          ;0     1
                GOTO    FDZ6
;*********************************************************************************
;***************  ++--  
FD51               ; 1
                BTFSC	PORTA,0     ;1+++  =0,  
                GOTO	IRQ_2
                BTFSS   FLUG_1    ;˨ ,3, 1  1++
                GOTO	DUD1

		BTFSS 	FLOG_2   ;+++  1  1  =1, 
		GOTO	DUD1

                BSF     FLOG_4   ; 1 ,   EEPROM
                BCF     FLOG_2    ;1  ר 1+++

		INCF		COUNT_ML,F   ;+       COUNT_ML (1=F)
		BTFSC		STATUS,Z     ;  =0,   
		INCF		COUNT_ST,F   ;+        (1=F)
		BTFSC		STATUS,Z     ;  =0,   
		INCF		DOPDED1,F   ;+
	
                GOTO    DUD1
;************************************************************************************************************
IRQ_2
                BSF     FLOG_2      ;1  ר 1+++
 DUD1           BTFSC	PORTA,0     ;1---  =0,   
                GOTO    FDG51
                BTFSS   FLUG_5    ;˨ ,2, 1  1--
                GOTO    DUD2

                BTFSS 	FLOG_5   ;---  1  1  =1,  . 
		GOTO	DUD2

               BSF     FLOG_4   ; 1 ,   EEPROM
               BCF     FLOG_5    ;1  ר 1---
 
          DECF    COUNT_ML,F   ;-       COUNT_ML (1=F)
          MOVLW	 .255          ;255    W   ()
	  XORWF    COUNT_ML,W    ;    Z      W  
	  BTFSS    STATUS,Z     ;  =0,   
	  GOTO	   DUD2        ;
          DECF     COUNT_ST,F   ;-        (1=F)
          MOVLW	 .255          ;255    W   ()
	  XORWF    COUNT_ST,W    ;    Z      W  
	  BTFSS    STATUS,Z     ;  =0,   
	  GOTO	   DUD2        ;
          DECF     DOPDED1,F   ;-  

          GOTO     DUD2  
;*********************************************************************************
FDG51              ; 2
                BSF     FLOG_5      ;1  ר 1---
 DUD2           BTFSC	PORTA,5     ;2+++  =0,   
                GOTO	IRQ_G2
                BTFSS   FLUG_6    ;˨ ,6, 1  2++
                GOTO    DUD3

                BTFSS 	FLOG_6   ;+++  1  2  =1,  . 
		GOTO	DUD3

               BSF     FLOG_4   ; 1 ,   EEPROM
               BCF     FLOG_6   ;1  ר 2+++

		INCF		COUNG_ML,F   ;+        (1=F)
		BTFSC		STATUS,Z     ;  =0,   
		INCF		COUNG_ST,F   ;+       (1=F)
		BTFSC		STATUS,Z     ;  =0, 
		INCF		DOPDED2,F   ;
	
                GOTO    DUD3
;*********************************************************************************
IRQ_G2
                BSF     FLOG_6      ;1  ר 2+++
 DUD3           BTFSC	PORTA,5     ;2---  =0,   
                GOTO    RET_IRD
                BTFSS   FLUG_7    ;˨ ,7, 1  2--
                GOTO    EEPR

                BTFSS 	FLOG_7   ;---   1  2  =1,  . 
		GOTO	EEPR

               BSF     FLOG_4   ; 1 ,   EEPROM
               BCF     FLOG_7   ;1  ר 2---
 
          DECF     COUNG_ML,F   ;-        (1=F)
          MOVLW	   .255          ;255    W   ()
	  XORWF    COUNG_ML,W    ;    Z      W  
	  BTFSS    STATUS,Z     ;  =0,   
	  GOTO	   EEPR        ;  ML
          DECF     COUNG_ST,F   ;-       (1=F)
          MOVLW	   .255          ;255    W   ()
	  XORWF    COUNG_ST,W    ;    Z      W  
	  BTFSS    STATUS,Z     ;  =0,   
	  GOTO	   EEPR        ;  ML
          DECF     DOPDED2,F   ;-       (1=F)

          GOTO     EEPR

RET_IRD         BSF     FLOG_7      ;1  ר 2---	
   ;**********************************************************************************************************
   ;**********************************************************************************************************
      ;*******   EEPROM   *******
 EEPR
		BTFSS 	FLOG_4   ; 1 ,   EEPROM  =1, 
		GOTO	LD23
		GOTO	LD24

LD23            MOVLW	.255           ;   W
		MOVWF	T_ZAP         ;     W   T_ZAP ()
                GOTO	IN54A
LD24		DECFSZ	T_ZAP          ; 
                GOTO	IN54A

        MOVF    COUNT_ML, 0   ;
        MOVWF   KOPY_D      ;
        MOVLW	.0
        MOVWF   KOPY_ADR    ; 
        CALL    WRITEE     ;  

        MOVF    COUNT_ST, 0   ;
        MOVWF   KOPY_D      ;
        MOVLW	.1
        MOVWF   KOPY_ADR    ; 
        CALL    WRITEE     ;  

        MOVF    COUNG_ML, 0   ;
        MOVWF   KOPY_D      ;
        MOVLW	.2
        MOVWF   KOPY_ADR    ; 
        CALL    WRITEE     ;  

        MOVF    COUNG_ST, 0   ;
        MOVWF   KOPY_D      ;
        MOVLW	.3
        MOVWF   KOPY_ADR    ; 
        CALL    WRITEE      ;  

        MOVF    DOPDED1, 0   ;
        MOVWF   KOPY_D      ;
        MOVLW	.4
        MOVWF   KOPY_ADR    ; 
        CALL    WRITEE       ;  

        MOVF    DOPDED2, 0   ;
        MOVWF   KOPY_D      ;
        MOVLW	.5
        MOVWF   KOPY_ADR    ; 
        CALL    WRITEE     ;  
   ;************************************************************************************************
         BCF     FLOG_4   ; 1 ,   EEPROM
  ;**********************************************************************************************************
  ;*********************************************************************************************************	
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
           ;,  1
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
IN54A
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                      ;  1  
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                MOVLW	.4
                MOVWF   STOPN11

                MOVF    DOPDED1,0      ;     (W=0)
                SUBWF   STOPN13,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STYY1

                MOVF    COUNT_ST,0      ;   COUNT_ST   (W=0)
                SUBWF   STOPN12,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STYY1

                MOVF    COUNT_ML,0      ;   COUNT_ML   (W=0)
                SUBWF   STOPN11,0
	BTFSC	STATUS, Z    ; Z=1 ( ) . . 
        GOTO    STY1
STYY1	BTFSS	STATUS,C    ;  =0,    :   = 1
	GOTO	STDS1
        BCF     PORTA,2     ;---
        BCF     FLUG_5    ;˨ ,2
	BCF     FLAG_5
        GOTO 	STDY1
STDS1   BSF     FLAG_5
        GOTO 	STDY1
STY1    BCF     PORTA,2     ;---
        BCF     FLUG_5    ;˨ ,2
	BCF     FLAG_5
STDY1
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                      ;  1  
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       ;     
        BCF       STATUS,Z ; 
        MOVF      PAM1,F   ; 
        BTFSC     STATUS,Z ; 1  (PAM1=0)
        GOTO      STDYP  ;

                MOVF    DOPDED1,0      ;     (W=0)
                SUBWF   STOPK13,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STYY3

                MOVF    COUNT_ST,0      ;     (W=0)
                SUBWF   STOPK12,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STYY3

                MOVF    COUNT_ML,0      ;   COUNT_ML   (W=0)
                SUBWF   STOPK11,0
	BTFSC	STATUS, Z    ; Z=1 ( ) . . 
        GOTO    STY3
STYY3   BTFSS	STATUS,C    ;  =0,    :   = 1
	GOTO	STDS3
        BSF     FLOG_3
        GOTO 	STDY3
STDS3   BCF     PORTA,3    ;+++
        BCF     FLUG_1    ;˨ ,3
        BCF     FLOG_3
        GOTO 	STDY3
STY3    BCF     PORTA,3    ;+++
        BCF     FLUG_1    ;˨ ,3
        BCF     FLOG_3
        GOTO 	STDY3
STDYP   BSF     FLOG_3
STDY3
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
           ;,  ,  1
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                BTFSS   FLUG_2   ;1    1
                GOTO    FDSD71

                MOVF    DOPDED1,0      ;     (W=0)
                SUBWF   MATDED1,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STAS

                MOVF    COUNT_ST,0      ;     (W=0)
                SUBWF   CAANT_ST,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STAS

                MOVF    COUNT_ML,0      ;      (W=0)
                SUBWF   CAANT_ML,0
	BTFSC	STATUS, Z    ; Z=1 ( ) . . 
        GOTO    STX
STAS	BTFSS	STATUS,C    ;  =0,    :   = 1
	GOTO	STD
        BCF     PORTA,2
        BCF     FLUG_5    ;˨ ,2
        BSF     PORTA,3
        BSF     FLUG_1    ;˨ ,3
        GOTO 	FDSD71

STD     BSF     PORTA,2
        BSF     FLUG_5    ;˨ ,2
        BCF     PORTA,3
        BCF     FLUG_1    ;˨ ,3
        GOTO 	FDSD71

STX     BCF     PORTA,2
        BCF     FLUG_5    ;˨ ,2
        BCF     PORTA,3
        BCF     FLUG_1    ;˨ ,3   
	BCF     FLUG_2

;++++++++++++++++++++++++
FDSD71    
              BTFSS   FLUG_3   ;1    1
              GOTO    FDS71

                MOVF    DOPDED2,0      ;     (W=0)
                SUBWF   MATDED2,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STAS5

                MOVF    COUNG_ST,0      ;     (W=0)
                SUBWF   COAND_ST,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STAS5

                MOVF    COUNG_ML,0      ;      (W=0)
                SUBWF   COAND_ML,0
	BTFSC	STATUS, Z    ; Z=1 ( ) . . 
        GOTO    STA54
STAS5	BTFSS	STATUS,C    ;   =0,     :   = 1
	GOTO	STD54
        BCF     PORTA,7
        BCF     FLUG_7    ;˨ ,7
        BSF     PORTA,6
        BSF     FLUG_6    ;˨ ,6
        GOTO 	FDS71

STD54   BSF     PORTA,7
        BSF     FLUG_7    ;˨ ,7
        BCF     PORTA,6
        BCF     FLUG_6    ;˨ ,6
        GOTO 	FDS71

STA54   BCF     PORTA,7
        BCF     FLUG_7    ;˨ ,7
        BCF     PORTA,6 
        BCF     FLUG_6    ;˨ ,6  
	BCF     FLUG_3
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
FDS71
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
           ;,  2
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                      ;  2  
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                MOVLW	.4
                MOVWF   STOPN21

                MOVF    DOPDED2,0      ;     (W=0)
                SUBWF   STOPN23,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STYY2

                MOVF    COUNG_ST,0      ;     (W=0)
                SUBWF   STOPN22,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STYY2

                MOVF    COUNG_ML,0      ;      (W=0)
                SUBWF   STOPN21,0
	BTFSC	STATUS, Z    ; Z=1 ( ) . . 
        GOTO    STY2
STYY2   BTFSS	STATUS,C    ;  =0,    :   = 1
	GOTO	STDS2
        BCF     PORTA,7    ;---
        BCF     FLUG_7    ;˨ ,7
        BCF     FLAG_7
        GOTO 	STDY2
STDS2   BSF     FLAG_7    ;, 
        GOTO 	STDY2
STY2    BCF     PORTA,7    ;---
        BCF     FLUG_7    ;˨ ,7
	BCF     FLAG_7
STDY2
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                     ;   2  
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       ;     
        BCF       STATUS,Z ; 
        MOVF      PAM2,F   ; 
        BTFSC     STATUS,Z ; 1 
        GOTO      STDYL  ;

                MOVF    DOPDED2,0      ;     (W=0)
                SUBWF   STOPK23,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STYY4

                MOVF    COUNG_ST,0      ;     (W=0)
                SUBWF   STOPK22,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STYY4

                MOVF    COUNG_ML,0      ;     (W=0)
                SUBWF   STOPK21,0
	BTFSC	STATUS, Z    ; Z=1 ( ) . . 
        GOTO    STY4
STYY4   BTFSS	STATUS,C    ;   =0,     :   = 1
	GOTO	STDS4
        BSF     FLAG_6
        GOTO 	STDY4
STDS4   BCF     PORTA,6  ;+++
        BCF     FLUG_6    ;˨ ,6
        BCF     FLAG_6
        GOTO 	STDY4
STY4    BCF     PORTA,6  ;+++
        BCF     FLUG_6    ;˨ ,6
	BCF     FLAG_6
        GOTO 	STDY4
STDYL   BSF     FLAG_6
STDY4
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
           ;,  ,  2
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                BTFSS   FLUG_0   ;1    2
                GOTO    FDSG7

                MOVF    DOPDED2,0      ;     (W=0)
                SUBWF   MATDED3,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STS5

                MOVF    COUNG_ST,0      ;     (W=0)
                SUBWF   COANT_ST,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STS5

                MOVF    COUNG_ML,0      ;     (W=0)
                SUBWF   COANT_ML,0
	BTFSC	STATUS, Z    ; Z=1 ( ) . . 
        GOTO    STSI
STS5	BTFSS	STATUS,C    ;   =0,     :   = 1
	GOTO	STBV
        BCF     PORTA,7
        BCF     FLUG_7    ;˨ ,7
        BSF     PORTA,6
        BSF     FLUG_6    ;˨ ,6
        GOTO 	FDSG7

STBV    BSF     PORTA,7
        BSF     FLUG_7    ;˨ ,7
        BCF     PORTA,6
        BCF     FLUG_6    ;˨ ,6
        GOTO 	FDSG7

STSI    BCF     PORTA,7
        BCF     FLUG_7    ;˨ ,7
        BCF     PORTA,6 
        BCF     FLUG_6    ;˨ ,6  
	BCF     FLUG_0
	
FDSG7	
;++++++++++++++++++++++++
                BTFSS   FLUG_4   ;1    2
                GOTO    FDS7

                MOVF    DOPDED1,0      ;     (W=0)
                SUBWF   MATDED4,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STSZ
         
                MOVF    COUNT_ST,0      ;   COUNT_ST   (W=0)
                SUBWF   CAAND_ST,0
	BTFSS	STATUS, Z    ; Z=1 ( ) . .  
	GOTO	STSZ

                MOVF    COUNT_ML,0      ;   COUNT_ML   (W=0)
                SUBWF   CAAND_ML,0
	BTFSC	STATUS, Z    ; Z=1 ( ) . . 
        GOTO    STS54
STSZ	BTFSS	STATUS,C    ;   =0,     :   = 1
	GOTO	STB54
        BCF     PORTA,2
        BCF     FLUG_5    ;˨ ,2
        BSF     PORTA,3
        BSF     FLUG_1    ;˨ ,3
        GOTO 	FDS7

STB54   BSF     PORTA,2
        BSF     FLUG_5    ;˨ ,2
        BCF     PORTA,3
        BCF     FLUG_1    ;˨ ,3
        GOTO 	FDS7

STS54   BCF     PORTA,2
        BCF     FLUG_5    ;˨ ,2
        BCF     PORTA,3
        BCF     FLUG_1    ;˨ ,3  
	BCF     FLUG_4	
FDS7	
	
	GOTO 	SNOVA
;*********************************************************************;
 ;-------------------------- 
;4 mgz - 3 
;delay = 3'000'000 machine cycles
Pause       movlw       .13
            movwf       Reg_1
            movlw       .57
            movwf       Reg_2
            movlw       .16
            movwf       Reg_3
wr          decfsz      Reg_1, F
            goto        wr
            decfsz      Reg_2, F
            goto        wr
            decfsz      Reg_3, F
            goto        wr
            nop
            nop
            return

;**************************************************************************************
;*****************    EEPROM ***************************************
WRITEE           movf    KOPY_D,W
                 bsf     STATUS,RP0 
                 bsf     EECON1,WREN 
                 movwf   EEDATA 
                 bcf     STATUS,RP0
                 movf    KOPY_ADR,W
                 bsf     STATUS,RP0 
                 movwf   EEADR
                 bcf     INTCON,GIE
                 movlw   0x55
                 movwf   EECON2
                 movlw   0xAA
                 movwf   EECON2
                 bsf     EECON1,WR
L96              BTFSC   EECON1, WR
                 GOTO	L96
                 bsf     INTCON,GIE
                 bcf     STATUS,RP0
                 return
;*****************    EEPROM ***************************************
READEE           movf    KOPY_ADR,W
                 bsf     STATUS,RP0
                BCF	INTCON, GIE
                 bcf     STATUS,RP1
                 movwf   EEADR
                 bsf     EECON1,RD
RRROM           BTFSC	EECON1, RD
                GOTO    RRROM
                 movf    EEDATA,W    ;    (W=0)
                 bcf     STATUS,RP0
                BSF	INTCON, GIE
                 return 
;**********************************************************

	END                       ;  



